Đến nội dung


Hình ảnh
- - - - -

Xin Lisp Tự Động Đo Chiều Dài Nhiều Line (Ko Tính Tổng)


  • Please log in to reply
8 replies to this topic

#1 AndUp

AndUp

    Chưa sử dụng CAD

  • Members
  • Pip
  • 3 Bài viết
Điểm đánh giá: 0 (bình thường)

Đã gửi 28 October 2016 - 12:10 AM

ví dụ em có 100 đường line rời rạc nằm đủ kiểu khác nhau nếu ngồi dim từng đường rất lâu nên nhờ các bác viết giúp em lisp chỉ cần quét qua tất cả các line là sẽ tự cho ra kết quả chiều dài của từng line, kết quả có thể trình bày theo dạng đường dim cũng được (nằm sát đường line ) hoặc dạng text sao cho text nằm trên đường line (không đè cắt ngang đường line) và góc quay của text cùng góc với từng đường line (text nằm song song ấy ạ)


  • 0

#2 ketxu

ketxu

    Copier - Paster - Editor

  • Moderator
  • PipPipPipPipPipPipPip
  • 5678 Bài viết
Điểm đánh giá: 2605 (tuyệt vời)

Đã gửi 28 October 2016 - 08:57 AM

Quick code cho bạn :

(defun c:qdd(/ s sp 3d i dxf rAng rSup e obj) (vl-load-com)
;Quick dim Lines @ketxu 10/2016
(cond
	((setq s (ssget '((0 . "LINE")))) 
	(setq 	sp	(vlax-get (setq ac (vla-get-activedocument (vlax-get-acad-object)))
					(if (> (vla-get-activespace  ac) 0) 'ModelSpace 'PaperSpace)) 
			3d vlax-3d-point
			i -1
			dxf (lambda(i e)(cdr (assoc i (entget e))))
			rAng (lambda(a)(if (and (> a (/ pi 2.)) (<= a (* pi 1.5)))(+ a pi) a))
			rSup (lambda(p)(vlax-put-property obj p 1))
			
	)
	(while (setq e (ssname s (setq i (1+ i))))
			(setq obj 
				(vla-adddimaligned sp 
					(3d (setq p1 (dxf 10 e))) 
                    (3d (setq p2 (dxf 11 e)))     
					(3d (polar p1 (+ (angle p1 p2) (/ pi 2.)) 0))
                )			
			)
			(vla-put-Textrotation obj (rAng (angle p1 p2)))
			(vla-put-TextOverride obj "<>\\P   ")
			(mapcar 'rSup '(DimLine1Suppress DimLine2Suppress ExtLine1Suppress ExtLine2Suppress))
	)	
)
))

  • 1

Thành viên nhóm CadMagic.
Mời bạn ghé thăm facebook nhóm - Page viết lisp theo yêu cầu  :
CAD MAGIC


#3 AndUp

AndUp

    Chưa sử dụng CAD

  • Members
  • Pip
  • 3 Bài viết
Điểm đánh giá: 0 (bình thường)

Đã gửi 29 October 2016 - 01:40 PM

Tks bác sẳn cho em hỏi trong đoạn code sau em sai chỗ nào với ạ
(Setq a (getstring "\n Nhập tên lô đất")
B (getreal "\n nhập số bắt đầu)
C 0)
(While
(Setq d (strcat a (+ b c))
C (+ c 1))
)
(Princ d) -> tới đây thì báo lỗi
  • 0

#4 ketxu

ketxu

    Copier - Paster - Editor

  • Moderator
  • PipPipPipPipPipPipPip
  • 5678 Bài viết
Điểm đánh giá: 2605 (tuyệt vời)

Đã gửi 29 October 2016 - 03:12 PM

Strcat yêu cầu đối số là các string. Trong đây bạn lại có tổng của b + c = số thực.

Ngoài ra hàm while của bạn đang không có điều kiện thoát


  • 0

Thành viên nhóm CadMagic.
Mời bạn ghé thăm facebook nhóm - Page viết lisp theo yêu cầu  :
CAD MAGIC


#5 Doan Van Ha

Doan Van Ha

    biết lệnh adcenter

  • CADViet Team
  • PipPipPipPipPipPipPip
  • 5447 Bài viết
Điểm đánh giá: 2624 (tuyệt vời)

Đã gửi 29 October 2016 - 03:18 PM

Thêm: thiếu 1 dấu " nữa


  • 1

* Chỉ nên yêu cầu Lisp khi bạn làm việc đó mất cả ngày nhưng họ chỉ viết 1 giờ. Đừng nêu yêu cầu Lisp khi bạn chỉ làm 1 giờ nhưng bắt họ phải mất cả ngày.

* Nhờ viết lisp cũng như đi khám bệnh. Chỉ gởi căn cước và than sắp chết thì không bác sỹ nào cứu sống được.


#6 AndUp

AndUp

    Chưa sử dụng CAD

  • Members
  • Pip
  • 3 Bài viết
Điểm đánh giá: 0 (bình thường)

Đã gửi 29 October 2016 - 04:01 PM

Em thêm (itoa (+ b c)) mà vẫn ko đc hic
  • 0

#7 ketxu

ketxu

    Copier - Paster - Editor

  • Moderator
  • PipPipPipPipPipPipPip
  • 5678 Bài viết
Điểm đánh giá: 2605 (tuyệt vời)

Đã gửi 29 October 2016 - 04:18 PM

Itoa lại là hàm chuyển đổi Integer sang String, trong khi b của bạn là Getreal => Kiểu số Real. (+ b c) trả về Real => lỗi

Khi sử dụng các hàm bạn phải chú ý yêu cầu về đối số của nó để cung cấp cho đúng, đừng vội vàng


  • 0

Thành viên nhóm CadMagic.
Mời bạn ghé thăm facebook nhóm - Page viết lisp theo yêu cầu  :
CAD MAGIC


#8 quanghuy181

quanghuy181

    biết vẽ arc

  • Members
  • PipPip
  • 41 Bài viết
Điểm đánh giá: 1 (bình thường)

Đã gửi 02 November 2016 - 03:45 PM

 

Quick code cho bạn :

(defun c:qdd(/ s sp 3d i dxf rAng rSup e obj) (vl-load-com)
;Quick dim Lines @ketxu 10/2016
(cond
	((setq s (ssget '((0 . "LINE")))) 
	(setq 	sp	(vlax-get (setq ac (vla-get-activedocument (vlax-get-acad-object)))
					(if (> (vla-get-activespace  ac) 0) 'ModelSpace 'PaperSpace)) 
			3d vlax-3d-point
			i -1
			dxf (lambda(i e)(cdr (assoc i (entget e))))
			rAng (lambda(a)(if (and (> a (/ pi 2.)) (<= a (* pi 1.5)))(+ a pi) a))
			rSup (lambda(p)(vlax-put-property obj p 1))
			
	)
	(while (setq e (ssname s (setq i (1+ i))))
			(setq obj 
				(vla-adddimaligned sp 
					(3d (setq p1 (dxf 10 e))) 
                    (3d (setq p2 (dxf 11 e)))     
					(3d (polar p1 (+ (angle p1 p2) (/ pi 2.)) 0))
                )			
			)
			(vla-put-Textrotation obj (rAng (angle p1 p2)))
			(vla-put-TextOverride obj "<>\\P   ")
			(mapcar 'rSup '(DimLine1Suppress DimLine2Suppress ExtLine1Suppress ExtLine2Suppress))
	)	
)
))

Bạn ơi mình muốn chiều dài cạnh chỉ lấy 1 số sau dấu , và chọn nhập chiều cao chữ thì làm như thế nào??? Xin cảm ơn!


  • 0

#9 Danh Cong

Danh Cong

    biết lệnh linetype

  • Members
  • PipPipPipPip
  • 242 Bài viết
Điểm đánh giá: 40 (tàm tạm)

Đã gửi 02 November 2016 - 04:23 PM

Bạn ơi mình muốn chiều dài cạnh chỉ lấy 1 số sau dấu , và chọn nhập chiều cao chữ thì làm như thế nào??? Xin cảm ơn!

 

"Text" bạn nhìn thấy thực chất là các đường dimention kích thước do bác @KetXu đã ẩn đi các đường gióng rồi.

 Muốn thay đổi số sau dấu phẩy hay là chiều cao chữ thì cứ vào "Dimention Style" hiện tại mà thay đổi theo ý thích thôi.  :D :D


  • 1

             ***  Vô lo - Vô nghĩ - Vô sầu hận  ***

***  Chẳng thương - Chẳng giận - Chẳng đau lòng  ***